<!--
 -
 -  $Id: foaf.xsl,v 1.1 2006/06/06 11:17:39 source Exp $
 -
 -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)
 -  project.
 -
 -  Copyright (C) 1998-2006 OpenLink Software
 -
 -  This project is free software; you can redistribute it and/or modify it
 -  under the terms of the GNU General Public License as published by the
 -  Free Software Foundation; only version 2 of the License, dated June 1991.
 -
 -  This program is distributed in the hope that it will be useful, but
 -  WITHOUT ANY WARRANTY; without even the implied warranty of
 -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 -  General Public License for more details.
 -
 -  You should have received a copy of the GNU General Public License along
 -  with this program; if not, write to the Free Software Foundation, Inc.,
 -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 -
 -
-->
<?xml version="1.0"?>
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:foaf="http://xmlns.com/foaf/0.1/"
  xmlns:vi="http://www.openlinksw.com/weblog/"
  xmlns:ods="http://www.openlinksw.com/virtuoso/ods/"
  xmlns:rss="http://purl.org/rss/1.0/"
  xmlns:geo="http://www.w3.org/2003/01/geo/wgs84_pos#"
  version="1.0">

  <xsl:output indent="yes" />

  <xsl:template match="/">
      <xsl:comment>FOAF based XML document generated By OpenLink Virtuoso</xsl:comment>
      <xsl:apply-templates />
  </xsl:template>

  <xsl:template match="*">
      <xsl:if test="ods:* and local-name() = 'seeAlso' and local-name(preceding-sibling::rdfs:seeAlso/ods:*) != local-name(ods:*)">
	  <xsl:variable name="ename" select="local-name(ods:*)"/>
	  <xsl:comment><xsl:value-of select="translate (substring ($ename, 1, 1), 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/><xsl:value-of select="substring ($ename, 2)"/> Data Space</xsl:comment>
      </xsl:if>
      <xsl:copy>
	  <xsl:copy-of select="@*[local-name()!='about']"/>
	  <xsl:if test="@rdf:about">
	      <xsl:attribute name="rdf:about"><xsl:value-of select="translate (@rdf:about, ' ', '+')"/></xsl:attribute>
	  </xsl:if>
	  <xsl:apply-templates />
      </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
